3 # Copyright (c) 2008, 2009, 2010, 2011, 2012 Nicira Networks, Inc.
5 # Licensed under the Apache License, Version 2.0 (the "License");
6 # you may not use this file except in compliance with the License.
7 # You may obtain a copy of the License at:
9 # http://www.apache.org/licenses/LICENSE-2.0
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
24 log='@LOGDIR@/ovs-pki.log'
28 # This option-parsing mechanism borrowed from a Autoconf-generated
29 # configure script under the following license:
31 # Copyright (C) 1992, 1993, 1994, 1995, 1996, 1998, 1999, 2000, 2001,
32 # 2002, 2003, 2004, 2005, 2006, 2009 Free Software Foundation, Inc.
33 # This configure script is free software; the Free Software Foundation
34 # gives unlimited permission to copy, distribute and modify it.
36 # If the previous option needs an argument, assign it.
37 if test -n "$prev"; then
43 *=*) optarg=`expr "X$option" : '[^=]*=\(.*\)'` ;;
47 case $dashdash$option in
52 ovs-pki, for managing a simple OpenFlow public key infrastructure
53 usage: $0 [OPTION...] COMMAND [ARG...]
55 The valid stand-alone commands and their arguments are:
56 init Initialize the PKI
57 req NAME Create new private key and certificate request
58 named NAME-privkey.pem and NAME-req.pem, resp.
59 sign NAME [TYPE] Sign switch certificate request NAME-req.pem,
60 producing certificate NAME-cert.pem
61 req+sign NAME [TYPE] Combine the above two steps, producing all three files.
62 verify NAME [TYPE] Checks that NAME-cert.pem is a valid TYPE certificate
63 fingerprint FILE Prints the fingerprint for FILE
64 self-sign NAME Sign NAME-req.pem with NAME-privkey.pem,
65 producing self-signed certificate NAME-cert.pem
67 The following additional commands manage an online PKI:
68 ls [PREFIX] [TYPE] Lists incoming requests of the given TYPE, optionally
69 limited to those whose fingerprint begins with PREFIX
70 flush [TYPE] Rejects all incoming requests of the given TYPE
71 reject PREFIX [TYPE] Rejects the incoming request(s) whose fingerprint begins
72 with PREFIX and has the given TYPE
73 approve PREFIX [TYPE] Approves the incoming request whose fingerprint begins
74 with PREFIX and has the given TYPE
75 expire [AGE] Rejects all incoming requests older than AGE, in
76 one of the forms Ns, Nmin, Nh, Nday (default: 1day)
77 prompt [TYPE] Interactively prompts to accept or reject each incoming
78 request of the given TYPE
80 Each TYPE above is a certificate type: 'switch' (default) or 'controller'.
82 Options for 'init', 'req', and 'req+sign' only:
83 -k, --key=rsa|dsa Type of keys to use (default: rsa)
84 -B, --bits=NBITS Number of bits in keys (default: 2048). For DSA keys,
85 this has an effect only on 'init'.
86 -D, --dsaparam=FILE File with DSA parameters (DSA only)
87 (default: dsaparam.pem within PKI directory)
88 Options for use with the 'sign' and 'approve' commands:
89 -b, --batch Skip fingerprint verification
90 Options that apply to any command:
91 -d, --dir=DIR Directory where the PKI is located
93 -f, --force Continue even if file or directory already exists
94 -l, --log=FILE Log openssl output to FILE (default: ovs-log.log)
95 -h, --help Print this usage message.
96 -V, --version Display version information.
101 echo "ovs-pki (Open vSwitch) @VERSION@"
141 echo "unrecognized option $option" >&2
145 if test -z "$command"; then
147 elif test -z "${arg1+set}"; then
149 elif test -z "${arg2+set}"; then
152 echo "$option: only two arguments may be specified" >&2
159 if test -n "$prev"; then
160 option=--`echo $prev | sed 's/_/-/g'`
161 { echo "$as_me: error: missing argument to $option" >&2
162 { (exit 1); exit 1; }; }
164 if test -z "$command"; then
165 echo "$0: missing command name; use --help for help" >&2
168 if test "$keytype" != rsa && test "$keytype" != dsa; then
169 echo "$0: argument to -k or --key must be rsa or dsa" >&2
172 if test "$bits" -lt 1024; then
173 echo "$0: argument to -B or --bits must be at least 1024" >&2
176 if test -z "$dsaparam"; then
177 dsaparam=$pkidir/dsaparam.pem
181 *) log="$PWD/$log" ;;
184 logdir=$(dirname "$log")
185 if test ! -d "$logdir"; then
186 mkdir -p -m755 "$logdir" 2>/dev/null || true
187 if test ! -d "$logdir"; then
188 echo "$0: log directory $logdir does not exist and cannot be created" >&2
193 if test "$command" = "init"; then
194 if test -e "$pkidir" && test "$force" != "yes"; then
195 echo "$0: $pkidir already exists and --force not specified" >&2
199 if test ! -d "$pkidir"; then
205 if test $keytype = dsa && test ! -e dsaparam.pem; then
206 echo "Generating DSA parameters, please wait..." >&2
207 openssl dsaparam -out dsaparam.pem $bits 1>&3 2>&3
210 # Get the current date to add some uniqueness to this certificate
211 curr_date=`date +"%Y %b %d %T"`
214 for ca in controllerca switchca; do
215 echo "Creating $ca..." >&2
220 mkdir -p certs crl newcerts
221 mkdir -p -m 0700 private
222 mkdir -p -m 0733 incoming
224 test -e crlnumber || echo 01 > crlnumber
225 test -e serial || echo 01 > serial
227 # Put DSA parameters in directory.
228 if test $keytype = dsa && test ! -e dsaparam.pem; then
232 # Write CA configuration file.
233 if test ! -e ca.cnf; then
234 sed "s/@ca@/$ca/g;s/@curr_date@/$curr_date/g" > ca.cnf <<'EOF'
237 distinguished_name = req_distinguished_name
239 [ req_distinguished_name ]
245 CN = OVS @ca@ CA Certificate (@curr_date@)
252 database = $dir/index.txt # index file.
253 new_certs_dir = $dir/newcerts # new certs dir
254 certificate = $dir/cacert.pem # The CA cert
255 serial = $dir/serial # serial no file
256 private_key = $dir/private/cakey.pem# CA private key
257 RANDFILE = $dir/private/.rand # random number file
258 default_days = 365 # how long to certify for
259 default_crl_days= 30 # how long before next CRL
260 default_md = md5 # md to use
261 policy = policy # default policy
262 email_in_dn = no # Don't add the email into cert DN
263 name_opt = ca_default # Subject name display option
264 cert_opt = ca_default # Certificate display option
265 copy_extensions = none # Don't copy extensions from request
266 unique_subject = no # Allow certs with duplicate subjects
270 countryName = optional
271 stateOrProvinceName = optional
272 organizationName = match
273 organizationalUnitName = optional
274 commonName = supplied
275 emailAddress = optional
279 # Create certificate authority.
280 if test $keytype = dsa; then
281 newkey=dsa:dsaparam.pem
285 openssl req -config ca.cnf -nodes \
286 -newkey $newkey -keyout private/cakey.pem -out careq.pem \
288 openssl ca -config ca.cnf -create_serial -out cacert.pem \
289 -days 2191 -batch -keyfile private/cakey.pem -selfsign \
290 -infiles careq.pem 1>&3 2>&3
291 chmod 0700 private/cakey.pem
299 if test -z "$arg1" || test -n "$arg2"; then
300 echo "$0: $command must have exactly one argument; use --help for help" >&2
306 if test -n "$arg2"; then
307 echo "$0: $command must have zero or one arguments; use --help for help" >&2
313 if test -z "$arg1"; then
314 echo "$0: $command must have one or two arguments; use --help for help" >&2
320 if test -e "$1" && test "$force" != "yes"; then
321 echo "$0: $1 already exists and --force not supplied" >&2
327 test -n "$type" || exit 123 # Forgot to call check_type?
333 echo "Prefix $arg1 is too short (less than 4 hex digits)" >&2
338 fingerprint=$(cd "$pkidir/${type}ca/incoming" && echo "$1"*-req.pem | sed 's/-req\.pem$//')
341 echo "No certificate requests matching $1" >&2
345 echo "$1 matches more than one certificate request:" >&2
346 echo $fingerprint | sed 's/ /\
354 req="$pkidir/${type}ca/incoming/$fingerprint-req.pem"
355 cert="$pkidir/${type}ca/certs/$fingerprint-cert.pem"
359 TMP=/tmp/ovs-pki.tmp$$
368 date=$(date -r $file)
369 if grep -e '-BEGIN CERTIFICATE-' "$file" > /dev/null; then
370 fingerprint=$(openssl x509 -noout -in "$file" -fingerprint |
371 sed 's/SHA1 Fingerprint=//' | tr -d ':')
373 fingerprint=$(sha1sum "$file" | awk '{print $1}')
375 printf "$name\\t$date\\n"
378 printf "\\t(correct fingerprint in filename)\\n"
381 printf "\\tfingerprint $fingerprint\\n"
386 verify_fingerprint() {
388 if test $batch != yes; then
389 echo "Does fingerprint match? (yes/no)"
391 if test "$answer" != yes; then
392 echo "Match failure, aborting" >&2
399 if test x = x"$1"; then
401 elif test "$1" = switch || test "$1" = controller; then
404 echo "$0: type argument must be 'switch' or 'controller'" >&2
410 number=$(echo $1 | sed 's/^\([0-9]\+\)\([[:alpha:]]\+\)/\1/')
411 unit=$(echo $1 | sed 's/^\([0-9]\+\)\([[:alpha:]]\+\)/\2/')
426 echo "$1: age not in the form Ns, Nmin, Nh, Nday (e.g. 1day)" >&2
430 echo $(($number * $factor))
434 if test ! -e "$1"; then
435 echo "$0: $1 does not exist" >&2
440 pkidir_must_exist() {
441 if test ! -e "$pkidir"; then
442 echo "$0: $pkidir does not exist (need to run 'init' or use '--dir'?)" >&2
444 elif test ! -d "$pkidir"; then
445 echo "$0: $pkidir is not a directory" >&2
451 must_not_exist "$arg1-privkey.pem"
452 must_not_exist "$arg1-req.pem"
454 cat > "$TMP/req.cnf" <<EOF
457 distinguished_name = req_distinguished_name
459 [ req_distinguished_name ]
464 OU = Open vSwitch certifier
465 CN = Open vSwitch certificate for $arg1
467 if test $keytype = rsa; then
468 (umask 077 && openssl genrsa -out "$1-privkey.pem" $bits) 1>&3 2>&3 \
471 must_exist "$dsaparam"
472 (umask 077 && openssl gendsa -out "$1-privkey.pem" "$dsaparam") \
475 openssl req -config "$TMP/req.cnf" -new -text \
476 -key "$1-privkey.pem" -out "$1-req.pem" 1>&3 2>&3
484 (cd "$pkidir/${type}ca" &&
485 openssl ca -config ca.cnf -batch -in /dev/stdin) \
486 < "$1" > "$2.tmp$$" 2>&3
492 if test "$files" != "$1"; then
498 if test "$command" = req; then
502 fingerprint "$arg1-req.pem"
503 elif test "$command" = sign; then
506 verify_fingerprint "$arg1-req.pem"
508 sign_request "$arg1-req.pem" "$arg2-cert.pem"
509 elif test "$command" = req+sign; then
515 sign_request "$arg1-req.pem" "$arg1-cert.pem"
516 fingerprint "$arg1-req.pem"
517 elif test "$command" = verify; then
519 must_exist "$arg1-cert.pem"
523 openssl verify -CAfile "$pkidir/${type}ca/cacert.pem" "$arg1-cert.pem"
524 elif test "$command" = fingerprint; then
528 elif test "$command" = self-sign; then
530 must_exist "$arg1-req.pem"
531 must_exist "$arg1-privkey.pem"
532 must_not_exist "$arg1-cert.pem"
534 # Create both the private key and certificate with restricted permissions.
536 openssl x509 -in "$arg1-req.pem" -out "$arg1-cert.pem.tmp" \
537 -signkey "$arg1-privkey.pem" -req -text) 2>&3 || exit $?
539 # Reset the permissions on the certificate to the user's default.
540 cat "$arg1-cert.pem.tmp" > "$arg1-cert.pem"
541 rm -f "$arg1-cert.pem.tmp"
542 elif test "$command" = ls; then
545 cd "$pkidir/${type}ca/incoming"
546 for file in $(glob "$arg1*-req.pem"); do
549 elif test "$command" = flush; then
552 rm -f "$pkidir/${type}ca/incoming/"*
553 elif test "$command" = reject; then
556 resolve_prefix "$arg1"
559 elif test "$command" = approve; then
562 resolve_prefix "$arg1"
565 cp "$req" "$TMP/$req"
566 verify_fingerprint "$TMP/$req"
567 sign_request "$TMP/$req"
568 rm -f "$req" "$TMP/$req"
569 elif test "$command" = prompt; then
574 cd "$pkidir/${type}ca/incoming"
575 for req in $(glob "*-req.pem"); do
576 cp "$req" "$TMP/$req"
578 cert=$(echo "$pkidir/${type}ca/certs/$req" |
579 sed 's/-req.pem/-cert.pem/')
580 if test -f $cert; then
581 echo "Request $req already approved--dropping duplicate request"
582 rm -f "$req" "$TMP/$req"
588 fingerprint "$TMP/$req" "$req"
589 printf "Disposition for this request (skip/approve/reject)? "
593 echo "Approving $req"
594 sign_request "$TMP/$req" "$cert"
595 rm -f "$req" "$TMP/$req"
598 echo "Rejecting $req"
599 rm -f "$req" "$TMP/$req"
606 elif test "$command" = expire; then
608 cutoff=$(($(date +%s) - $(parse_age ${arg1-1day})))
609 for type in switch controller; do
610 cd "$pkidir/${type}ca/incoming" || exit 1
611 for file in $(glob "*"); do
612 time=$(date -r "$file" +%s)
613 if test "$time" -lt "$cutoff"; then
619 echo "$0: $command command unknown; use --help for help" >&2